include head.h
program color
integer numlam, index
parameter (numlam=NUMLAM)
double precision xx2(NZ*NR, NPH)
real zmatr(NR, NZ)
real zmin, zmax
real wpos, wneg
integer i,j

open (1, file='images',access='direct',recl=8*NZ*NR*NPH)

100   print *, 'INPUT the index of the image:'
read *, index
if (index>numlam) {
    close(1)
    stop
}

read(1, rec=index)xx2
print *, xx2
zmax=0.
zmin=0.

do i=1, NZ*NR{
    do j=1, NPH{
	if ( zmin>xx2(i,j) ) { zmin=xx2(i,j) }
	if ( zmax<xx2(i,j) ) { zmax=xx2(i,j) }
	if ( xx2(i,j) < 0 ) { 
	    wneg=wneg+xx2(i,j)*xx2(i,j)
	    xx2(i,j)=0 
	}
	else {
	    wpos=wpos+xx2(i,j)*xx2(i,j)
	}
    }
}	

print *, 'zmin', zmin, '  zmax', zmax
print *, 'w_neg',wneg,'  w_pos',wpos
do k=1,NPH { 
    do n=1,NZ {
	do m=1,NR {	
	     #zmatr(m,n)=xx2(n+NZ*(m-1),k)
	     zmatr(m,n)=xx2(m+NR*(n-1),k)
	}  
    }  
    call color3(zmatr, NR, NZ, 0., zmax,'R', 'Z', 'Object')
}
goto 100
end

subroutine color3(zmatr, nx, ny, zmin, zmax,tx, ty, titl)
# zmatr(nx, ny) is the z-value for mesh (nx,ny)
# tx, ty, titl are the titles for x-axis, y-axis, and the whole graph
integer nx, ny
real zmatr(nx,ny)
character*20 tx, ty, titl
real zmin, zmax

call METAFL ('xwin')  
call DISINI
call COMPLX 
call PAGERA  
call autres(nx+1,ny+1)	
call axspos(450, 1800)
call ax3len(1400,1400, 1400)
call name (tx, 'x')    
call name (ty, 'y')  
call ticks(1,'xy')
call digits(0,'xy')
call digits(4,'z')
call graf3(0.,float(nx),0.,1.,0.,float(ny),0.,1.,zmin, zmax, zmin,(zmax-zmin)/5)
call titlin (titl, 1)
call title
call crvmat(zmatr,nx,ny,1,1)
call DISFIN 

return
end
